EllipsoidsRenderer
Date: 2019-10-22

org.jmol.renderspecial

## Class EllipsoidsRenderer

- java.lang.Object
- - org.jmol.render.ShapeRenderer
  - - org.jmol.renderspecial.EllipsoidsRenderer

-     public final class EllipsoidsRenderer
      extends ShapeRenderer

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `private javajs.util.V3[]` | `axes`
    `private static int[]` | `axisPoints`
    `private boolean[]` | `bGlobals`
    `private boolean[]` | `bOptions`
    `private javajs.util.BS` | `bsTemp`
    `private javajs.util.P3` | `center`
    `private double[]` | `coefs`
    `private int[]` | `coords`
    `private static float[]` | `cossin`
    `private int` | `diameter`
    `private int` | `diameter0`
    `private int` | `dotCount`
    `private int` | `dotScale`
    `private int` | `dx`
    `private int` | `eigenSignMask`
    `private Ellipsoids` | `ellipsoids`
    `private float[]` | `factoredLengths`
    `private boolean` | `fillArc`
    `private int` | `iCutout`
    `private boolean` | `isSet`
    `private javajs.util.M3` | `mat`
    `private javajs.util.M3` | `matEllipsoidToScreen`
    `private javajs.util.M3` | `matScreenToCartesian`
    `private javajs.util.M3` | `matScreenToEllipsoid`
    `private javajs.util.M4` | `mDeriv`
    `private javajs.util.M3` | `mTemp`
    `private static int[]` | `octants`
    `private static int` | `OPT_ARCS`
    `private static int` | `OPT_ARROWS`
    `private static int` | `OPT_AXES`
    `private static int` | `OPT_BALL`
    `private static int` | `OPT_COUNT`
    `private static int` | `OPT_DOTS`
    `private static int` | `OPT_FILL`
    `private static int` | `OPT_WIREFRAME`
    `private java.lang.String[]` | `OPTS`
    `private float` | `perspectiveFactor`
    `private javajs.util.P3[]` | `points`
    `private javajs.util.P3` | `pt1`
    `private javajs.util.P3` | `pt2`
    `private javajs.util.P3` | `s0`
    `private javajs.util.P3` | `s1`
    `private javajs.util.P3` | `s2`
    `private javajs.util.P3[]` | `screens`
    `private int` | `selectedOctant`
    `private javajs.util.P3[]` | `selectedPoints`
    `private static float` | `toRadians`
    `private static javajs.util.V3[]` | `unitAxisVectors`
    `private javajs.util.V3` | `v1`
    `private javajs.util.V3` | `v2`
    `private javajs.util.V3` | `v3`

    - ### Fields inherited from class org.jmol.render.ShapeRenderer

      `colix, exportType, g3d, isExport, mad, ms, myVisibilityFlag, shape, shapeID, tm, vwr`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `EllipsoidsRenderer()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `private void` | `fillConeScreen(javajs.util.P3 p1, javajs.util.P3 p2, boolean isPositive)`
    `protected boolean` | `render()`
    `private void` | `renderArc(int ptA, int ptB)`
    `private void` | `renderArcs()`
    `private void` | `renderArrows()`
    `private void` | `renderAxes()`
    `private void` | `renderBall()`
    `private void` | `renderDots()`
    `private boolean` | `renderEllipsoids(java.util.Map<?,Ellipsoid> ht, boolean isSimple)`
    `private void` | `renderOne(Ellipsoid e)`
    `private void` | `setAxes(int maxPt)`
    `private boolean` | `setGlobals()`
    `private void` | `setLogic()`
    `private void` | `setMatrices()`
    `private void` | `setOptions(java.lang.String options)`
    `private void` | `setSelectedOctant()`

    - ### Methods inherited from class org.jmol.render.ShapeRenderer

      `initRenderer, isVisibleForMe, renderShape, setup, setViewerG3dShapeID`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### ellipsoids

          private Ellipsoids ellipsoids

    - #### bGlobals

          private boolean[] bGlobals

    - #### bOptions

          private boolean[] bOptions

    - #### OPTS

          private final java.lang.String[] OPTS

    - #### OPT_DOTS

          private static final int OPT_DOTS

      See Also:
        Constant Field Values

    - #### OPT_ARCS

          private static final int OPT_ARCS

      See Also:
        Constant Field Values

    - #### OPT_AXES

          private static final int OPT_AXES

      See Also:
        Constant Field Values

    - #### OPT_FILL

          private static final int OPT_FILL

      See Also:
        Constant Field Values

    - #### OPT_BALL

          private static final int OPT_BALL

      See Also:
        Constant Field Values

    - #### OPT_ARROWS

          private static final int OPT_ARROWS

      See Also:
        Constant Field Values

    - #### OPT_WIREFRAME

          private static final int OPT_WIREFRAME

      See Also:
        Constant Field Values

    - #### OPT_COUNT

          private static final int OPT_COUNT

      See Also:
        Constant Field Values

    - #### fillArc

          private boolean fillArc

    - #### isSet

          private boolean isSet

    - #### diameter

          private int diameter

    - #### diameter0

          private int diameter0

    - #### dotCount

          private int dotCount

    - #### dotScale

          private int dotScale

    - #### dx

          private int dx

    - #### eigenSignMask

          private int eigenSignMask

    - #### iCutout

          private int iCutout

    - #### selectedOctant

          private int selectedOctant

    - #### coords

          private int[] coords

    - #### axes

          private javajs.util.V3[] axes

    - #### center

          private javajs.util.P3 center

    - #### perspectiveFactor

          private float perspectiveFactor

    - #### bsTemp

          private javajs.util.BS bsTemp

    - #### mat

          private javajs.util.M3 mat

    - #### mTemp

          private javajs.util.M3 mTemp

    - #### mDeriv

          private javajs.util.M4 mDeriv

    - #### matScreenToCartesian

          private javajs.util.M3 matScreenToCartesian

    - #### matScreenToEllipsoid

          private javajs.util.M3 matScreenToEllipsoid

    - #### matEllipsoidToScreen

          private javajs.util.M3 matEllipsoidToScreen

    - #### coefs

          private final double[] coefs

    - #### factoredLengths

          private final float[] factoredLengths

    - #### selectedPoints

          private final javajs.util.P3[] selectedPoints

    - #### v1

          private final javajs.util.V3 v1

    - #### v2

          private final javajs.util.V3 v2

    - #### v3

          private final javajs.util.V3 v3

    - #### pt1

          private final javajs.util.P3 pt1

    - #### pt2

          private final javajs.util.P3 pt2

    - #### s0

          private final javajs.util.P3 s0

    - #### s1

          private final javajs.util.P3 s1

    - #### s2

          private final javajs.util.P3 s2

    - #### toRadians

          private static final float toRadians

      See Also:
        Constant Field Values

    - #### cossin

          private static final float[] cossin

    - #### unitAxisVectors

          private static final javajs.util.V3[] unitAxisVectors

    - #### screens

          private final javajs.util.P3[] screens

    - #### points

          private final javajs.util.P3[] points

    - #### axisPoints

          private static int[] axisPoints

    - #### octants

          private static int[] octants

  - ### Constructor Detail

    - #### EllipsoidsRenderer

          public EllipsoidsRenderer()

  - ### Method Detail

    - #### render

          protected boolean render()

      Specified by:
        `render` in class `ShapeRenderer`

    - #### setGlobals

          private boolean setGlobals()

    - #### setOptions

          private void setOptions(java.lang.String options)

    - #### setLogic

          private void setLogic()

    - #### renderEllipsoids

          private boolean renderEllipsoids(java.util.Map<?,Ellipsoid> ht,
                                           boolean isSimple)

    - #### renderOne

          private void renderOne(Ellipsoid e)

    - #### setMatrices

          private void setMatrices()

    - #### setAxes

          private void setAxes(int maxPt)

    - #### renderBall

          private void renderBall()

    - #### renderArrows

          private void renderArrows()

    - #### fillConeScreen

          private void fillConeScreen(javajs.util.P3 p1,
                                      javajs.util.P3 p2,
                                      boolean isPositive)

    - #### renderAxes

          private void renderAxes()

    - #### renderDots

          private void renderDots()

    - #### renderArcs

          private void renderArcs()

    - #### renderArc

          private void renderArc(int ptA,
                                 int ptB)

    - #### setSelectedOctant

          private void setSelectedOctant()